// This is the leap motion controller.
var controller;
var mesh;

// The leap motion camera controlls

var camcontrol;

// The three.js variables. The scene where everything sits and the camera

var scene, camera, renderer;

// Quanternion stuff.
var quanternionX, vectorX;
var quanternionY, vectorY;
var quanternionZ, vectorZ;

// Leap Motion stuff.
var pointable, stableish;

// Axis position.
var XPos, YPos, ZPos;

//Colour of the box being rotated
var boxColor;

// Quanternion is used for rotating without encountering the dreaded gimbal lock issue. 
function X(distance) {
    quanternionX = new THREE.Quaternion();
    quanternionX.setFromAxisAngle(new THREE.Vector3(1, 0, 0), Math.PI / 2);
    vectorX = new THREE.Vector3(1, 0, 0);
    distance = vectorX.applyQuaternion(quanternionX);
    return distance;

}


function Y(distance) {
    quanternionY = new THREE.Quaternion();
    quanternionY.setFromAxisAngle(new THREE.Vector3(0, 0, ), Math.PI / 2);
    vectorY = new THREE.Vector3(0,1 , 0);
    distance = vectorY.applyQuaternion(quanternionY);
    return distance;
}

function Z(distance) {
    quaternionZ = new THREE.Quaternion();
    quaternionZ.setFromAxisAngle(new THREE.Vector3(0, 0, 1), Math.PI / 2);
    vectorZ = new THREE.Vector3(0, 0, 1);
    distance = vectorZ.applyQuaternion(quaternionZ);
    return distance;
}

controller= Leap.loop(function (frame) {
    pointable = frame.pointables[0];
    if (pointable) {
        XPos = X(pointable.tipPosition[0]);
        Ypos = Y(pointable.tipPosition[1]);
        ZPos = Z(pointable.tipPosition[2]);
        animate(XPos, YPos, ZPos);
    }
});
controller.connect();

init();
animate();
function init() {

    // Initialization of three.js. The scene, camera and the thing that reders it all.
    scene = new THREE.Scene();
    camera = new THREE.PerspectiveCamera(75, window.innerWidth / window.innerHeight, 1, 1000);
    camera.position.z = 500;

    // Connects the leap motion controller.
    boxColor = new THREE.Color("rgb(85,37,130)");
    geometry = new THREE.CubeGeometry(100, 100, 100);
    material = new THREE.MeshBasicMaterial({
        color: boxColor,
        wireframe: true,
        wireframeLinewidth: 10
    });
   mesh = new THREE.Mesh(geometry, material); // the mesh has the cube's dimention and material which depcits what it looks like etc
   scene.add(mesh);

   renderer = new THREE.CanvasRenderer();
   renderer.setSize(window.innerWidth, window.innerHeight);

   document.body.appendChild(renderer.domElement);
}

console.log(renderer.domElement);


function animate(XPos, YPos, ZPos) {
    // The rendering stuff for three.js goes in this function.
    
    mesh.rotation.x = XPos / 200;
    mesh.rotation.y = YPos / 200;
    mesh.rotation.z = ZPos / 200;
    renderer.render(scene, camera);
    requestAnimationFrame(animate);
    // controls.update();

}

